#!/bin/sh

set -x

export WDIR=/mnt/free/newspapers/Dagbladet
export IDIR=/mnt/free/newspapers/Dagbladet/downloadUD
export ADIR=/mnt/free/newspapers/Dagbladet/Forrige
export SDIR=/mnt/free/newspapers/Dagbladet/log

date >> $SDIR/log.txt
echo Wireless trondheim downloader >> $SDIR/log.txt

/usr/bin/wireless.sh start WirelessTrondheim
if [ $? -ne 0 ]; then
	echo Failed to connect to wireless >> $SDIR/log.txt
	cp $IDIR/iconA.png $SDIR/icon.png
	echo "<?xml version=\"1.0\" encoding=\"utf-8\"?><package><metadata><dc-metadata><Title>Logg</Title><Description>Klarte ikke å koble seg til Trådløse Trondheim</Description><Date>2008-04-16T18:02:24</Date></dc-metadata><y-metadata><startpage>log.txt</startpage><image>icon.png</image><version>000</version></y-metadata></metadata><last-location><pagenumber>1</pagenumber></last-location><viewer-settings><zoomfactor>zoomPage</zoomfactor><rotation>0</rotation><positionx>2</positionx><positiony>0</positiony><mode>page</mode></viewer-settings></package>" > $SDIR/manifest.xml
	exit 1 
fi

i=db

mv $IDIR/contents.txt $IDIR/old_contents.txt

wget -O $IDIR/contents.txt http://folk.ntnu.no/hakonror/iliad/pdf/contentsDB.txt

# if not able to download, exit
if [ $? -ne 0 ]; then
	echo Failed to download contentfile >> $SDIR/log.txt
	cp $IDIR/iconA.png $SDIR/icon.png
	echo "<?xml version=\"1.0\" encoding=\"utf-8\"?><package><metadata><dc-metadata><Title>Logg</Title><Description>Klarte ikke å laste ned innholdsfila</Description><Date>2008-04-16T18:02:24</Date></dc-metadata><y-metadata><startpage>log.txt</startpage><image>icon.png</image><version>000</version></y-metadata></metadata><last-location><pagenumber>1</pagenumber></last-location><viewer-settings><zoomfactor>zoomPage</zoomfactor><rotation>0</rotation><positionx>2</positionx><positiony>0</positiony><mode>page</mode></viewer-settings></package>" > $SDIR/manifest.xml
	exit 1 
fi

loc=$(cat old_contents.txt)
serv=$(cat contents.txt)

echo loc: $loc >> $SDIR/log.txt
echo serv: $serv >> $SDIR/log.txt

if [ $serv -gt $loc ]; then
	rm -rf $ADIR/$i.pdf
	rm /tmp/$i.pdf
	mv $WDIR/$i.pdf $ADIR 
	mkdir -p $WDIR/$i.pdf

	echo "<?xml version=\"1.0\" encoding=\"utf-8\"?><package><metadata><dc-metadata><Title>Dagbladet</Title><Description>Dagbladet</Description><Date>2008-04-16T18:02:24</Date></dc-metadata><y-metadata><startpage>$i.pdf</startpage><image>icon.png</image><version>000</version></y-metadata></metadata><last-location><pagenumber>1</pagenumber></last-location><viewer-settings><zoomfactor>zoomPage</zoomfactor><rotation>0</rotation><positionx>2</positionx><positiony>0</positiony><mode>page</mode></viewer-settings></package>" > $WDIR/$i.pdf/manifest.xml

	wget -O /tmp/$i.pdf http://folk.ntnu.no/hakonror/iliad/pdf/$i.pdf
	# if not able to download, exit
	if [ -f /tmp/$i.pdf ]; then
		echo Newspaper downloaded >> $SDIR/log.txt
		cp $IDIR/iconB.png $SDIR/icon.png
		echo "<?xml version=\"1.0\" encoding=\"utf-8\"?><package><metadata><dc-metadata><Title>Logg</Title><Description>Avis nedlastet</Description><Date>2008-04-16T18:02:24</Date></dc-metadata><y-metadata><startpage>log.txt</startpage><image>icon.png</image><version>000</version></y-metadata></metadata><last-location><pagenumber>1</pagenumber></last-location><viewer-settings><zoomfactor>zoomPage</zoomfactor><rotation>0</rotation><positionx>2</positionx><positiony>0</positiony><mode>page</mode></viewer-settings></package>" > $SDIR/manifest.xml
		mv /tmp/$i.pdf $WDIR/$i.pdf/$i.pdf

		cp $IDIR/icon.png $WDIR/$i.pdf/icon.png

		/usr/bin/wireless.sh stop
		
		exit 0
	
	fi

	
	echo Failed to download newspaper >> $SDIR/log.txt
	cp $IDIR/iconA.png $SDIR/icon.png
	echo "<?xml version=\"1.0\" encoding=\"utf-8\"?><package><metadata><dc-metadata><Title>Logg</Title><Description>Klarte ikke å laste ned avisen</Description><Date>2008-04-16T18:02:24</Date></dc-metadata><y-metadata><startpage>log.txt</startpage><image>icon.png</image><version>000</version></y-metadata></metadata><last-location><pagenumber>1</pagenumber></last-location><viewer-settings><zoomfactor>zoomPage</zoomfactor><rotation>0</rotation><positionx>2</positionx><positiony>0</positiony><mode>page</mode></viewer-settings></package>" > $SDIR/manifest.xml
	/usr/bin/wireless.sh stop
	exit 1 
	
fi

set +x

