# coding: utf-8
#gets body and stuff via rss
#inspiration and help from "http://www.xml.com/lpt/a/1080"
#and "http://www.boddie.org.uk/python/HTML.html"

from xml.dom import minidom
from xml.dom.ext.reader import HtmlLib
import urllib
from urllib import urlretrieve, urlopen, urlcleanup
from BeautifulSoup import BeautifulSoup, BeautifulStoneSoup
import operator
from time import sleep, strftime
import random
import pickle
from shutil import copyfile
import filecmp
import re
import os.path

path_rss_xml = "/home/hraune/Master_prog/xml_up/rss/"


def saveRSSasXML(url, upload_path = "/home/hraune/Master_prog/xml_up/", filename = "testRSS.xml"):
	urlretrieve(url, upload_path+filename)

#gets rss from a given url
def rssload(rssURL):
	print "loading RSS from: " + rssURL
	#saveRSSasXML(rssURL)
	return minidom.parse(urllib.urlopen(rssURL))
	
#to enable the reading of all kinds of rssfeeds, 0.90 to 2.0, the use of namespaces is required
DEFAULT_NAMESPACES = \
	(None, # RSS 0.91, 0.92, 0.93, 0.94, 2.0
	'http://purl.org/rss/1.0/', # RSS 1.0
	'http://my.netscape.com/rdf/simple/0.9/' # RSS 0.90
	)

#returns a list of elements depending on the namespace with a given name
def getElementsByTagName(node, tagName, possibleNamespaces=DEFAULT_NAMESPACES):
	for namespace in possibleNamespaces:
		children = node.getElementsByTagNameNS(namespace, tagName)
		if len(children):
			return children
	return []

#returns first element of a given tagname
def first(node, tagName, possibleNamespaces=DEFAULT_NAMESPACES):
	children = getElementsByTagName(node, tagName, possibleNamespaces)
	return len(children) and children[0] or None

#returns all the text of a given node.
def textOf(node):
	return node and "".join([child.data for child in node.childNodes]) or ""

#dublin core is a metadata element set for crossdomain information resource description
DUBLIN_CORE = ('http://purl.org/dc/elements/1.1/',)

#for replacing of some of the garbled and escaped characters one will encounter
def easyReplacer(aString):
	oe = "&amp;oslash;" # => "ø"
	aa = "&amp;aring;" # => "å"
	Aa = "&amp;Aring;" # => "Å"
	Aa2 = "&Aring;"  #
	ae = "&amp;eacute;" # => "æ"
	ae2 = "&amp;aelig;" # => "æ"
	oe2 = "&oslash;"
	aa2 = "&aring;"
	ae3 = "&eacute;"
	ae4 = "&aelig;"
	nbsp2 = "&nbsp;"
	returString = aString
	returString = returString.replace(oe, "ø").replace(aa, "å").replace(Aa, "Å").replace(Aa2, "Å")
	returString = returString.replace(ae, "æ").replace(ae2, "æ").replace(oe2, "ø").replace(aa2, "å")
	returString = returString.replace(ae3, "æ").replace(nbsp2, " ").replace(ae4, "æ")
	return returString

#for replacing of some of the garbled and escaped characters one will encounter
def replacer(aString, body=False):
	oe = "&amp;oslash;" # => "ø"
	aa = "&amp;aring;" # => "å"
	Aa = "&amp;Aring;" # => "Å"
	Aa2 = "&Aring;"  #
	ae = "&amp;eacute;" # => "æ"
	ae2 = "&amp;aelig;" # => "æ"
	oe2 = "&oslash;"
	aa2 = "&aring;"
	ae3 = "&eacute;"
	nbsp2 = "&nbsp;"
	br = "&lt;br /&gt;"
	lt = "&lt;"
	gt = "&gt;"
	r = "&amp;#345;"   # =>  ř 
	nbsp = "&amp;nbsp;" # => " "
	laquo = "&amp;laquo;" # => "<<"
	raquo = "&amp;raquo;" # => ">>"
	ndash = "&amp;ndash;" # => "-"
	span = '&lt;span style="font-style: italic" class="Apple-style-span"&gt;'
	span1 = '&lt;span style="font-family: ' + "'-webkit-monospace'; font-size: 12px; white-space: pre-wrap;" + " -webkit-border-horizontal-spacing: 1px; -webkit-border-vertical-spacing" + ': 1px" class="Apple-style-span"&gt;'
	span2 = '<span style="font-style: italic" class="Apple-style-span">'
	span3 = '<span style="font-weight: bold" class="Apple-style-span">'
	span2_end = '</span>'
	returString = aString.replace(oe, "ø").replace(aa, "å").replace(ae, "æ").replace(nbsp, " ").replace(" ? ", " - ")
	returString = returString.replace(oe2, "ø").replace(aa2, "å").replace(ae3, "æ").replace(nbsp2, " "). replace(Aa2, "Å")
	returString = returString.replace(span1, "").replace(laquo, "«").replace(raquo, "»").replace(ndash, "-").replace(ae2, "æ")
	returString = returString.replace("&lt;/p&gt;", "").replace(span, "").replace("&lt;/span&gt;", "").replace("&lt;p&gt;", "")
	returString = returString.replace(br, "<br/>").replace(span3, "")
	if body == True:
		returString = returString.replace(span2, "").replace(span2_end, "")
	returString = returString.replace(r, "r").replace(lt, "<").replace(gt, ">")
	return returString
	
#replacer method for db.no
def replacerDB(aString, body=False):
	aa = "&#xe5;"
	ae = "&#xe6;"
	oe = "&#xf8;"
	ab = "&#xab;"
	bb = "&#xbb;"
	returstring = aString.replace(aa, "å").replace(ae ,"æ").replace(oe, "ø").replace(ab, "«").replace(bb, "»")
	return returString



# gets article information from a given rss url
def getArticles(rssurl, newspaper):
	new_articles = False
	pickledir = "/home/hraune/Master_prog/pdf/pickle/" + newspaper + "/"

	body = ""
	rssDocument = rssload(rssurl)
	category = ""
	
	if newspaper == "db":
		for item in getElementsByTagName(rssDocument, "channel"):
			category = textOf(first(item, "title"))
			category = category.split(" - ")[1]
	elif newspaper == "vg":
		for item in getElementsByTagName(rssDocument, "channel"):
			category = textOf(first(item, "description"))
			category = category.split(":  ")
			if len(category) < 1:
				category = category.split("VG RSS Kategori:")[1]
				print "cat: " + category
			elif len(category) > 1:
				category = category[0]
				cateogry = category.replace("VG RSS", ""	)
	elif newspaper == "ad":
		for item in getElementsByTagName(rssDocument, "channel"):
			category = textOf(first(item, "title"))
			category = category.split(" | ")[1]
			
	news = []
	temp = []
	for item in getElementsByTagName(rssDocument, 'item'):
		article = {}
		title = textOf(first(item, 'title')).encode("utf-8")
		title = title.replace("\n", "")
		
		picklefile = pickledir + title.lower().replace(" ", "_").replace("/", "") + ".p" 
		present = os.path.isfile(picklefile)
		print "picklefile and its presence: " + str(picklefile) + " -> " + str(present)
		if present == True:
			try:
				# Load the dictionary back from the pickle file, if it excists.
				pickled_article = pickle.load(open(pickledir + title.lower().replace(" ", "_") + ".p" ))
				print "Found pickle: " + pickled_article["title"]
				if pickled_article["title"] == title:
					pickled_article["pickled"] = True
					news.append(pickled_article)
					continue
			except IOError:
				print "File flunked"
						
		article["title"] = title
		article["pickled"] = False
		link = textOf(first(item, 'link')).split("/http")
		if len(link) == 1:
			article["link"] = link[0]
		
		else:
			article["link"] = "http" + link[1]
		ingress = textOf(first(item, 'description')).encode("utf-8")
		article["ingress"] = easyReplacer(ingress.split("<img")[0])
		print "" + article["ingress"]
		article["published"] = textOf(first(item, 'pubDate'))
		article["category"] = category
		article["author_text"]= "n/a"   #textOf(first(item, 'author'))
		article["author_ill"]= "n/a"
		article["skip"] = False
		temp.append(article)
		
	print "Total number of articles from rss: " + str(len(temp))
	for article in temp:
		if article["pickled"] == True:
			print str(article["title"]) + "was pickled"
			continue
		if article["link"] == "http://www.dagbladet.no/hestesport/travtips.html" or article["link"] == "http://www.123spill.no/" or article["link"][:27] == "http://www.dagbladet.no/tv/":
			article["skip"] = True
			continue
		#print "||||||||||||||||||||"
		#print article["link"]
		#print "processing " + str(article["title"])
		url = article["link"]
		if newspaper == "ad":
			url = url.replace("\n", "")
			url += "?service=print"
			if "adressa.no./tv/" in url:
				print "tv link. bail"
				continue
		print url
		body = urlopen(url)
		
		
		soup = BeautifulSoup(body)
		
		tips = '<a title="Kr. 24 000 til månedens beste tips!" href="http://www.dagbladet.no/info/">'
		tips2 = '<a title="Kr. 24 000 til månedens beste tips!\n" href="http://www.dagbladet.no/info/"></a>'
		ims = '<img style="CLEAR: both; BORDER-RIGHT: 0px; BORDER-TOP: 0px; FLOAT: right; MARGIN: 10px 0px 10px 10px; BORDER-LEFT: 0px; WIDTH: 168px; BORDER-BOTTOM: 0px; HEIGHT: 116px" src="http://gfx.dagbladet.no/g3/tipsoss168x116.gif" /></a>'
		
		
		if newspaper == "db":
			art = soup.find(id = "article-text")
			if art == None:
				print "shit happened"
				continue
			body = str(art).split("</div><!--group-->")
			if len(body) > 1:
				body = body[1].split('<div class="cr">')[0]

			text = BeautifulSoup(str(body))
			bgone = text.findAll({'a':True, 'img':True, 'table':True})  #
			for b in bgone:
				print "b.contents: " + str(len(b.contents))
				if b.contents == []:
					continue
				else:
					print "inni" 
					body = str(body).replace(str(b), str(b.contents[0]))
				body = str(body).replace(str(b), str(b.contents[0]))
			body = body.replace(tips2, "")
			ill = ""
			for img in soup.findAll('img'):
				if str(img.get("class")) == "pano-image":
					print "img: " + str(img) + " len " + str(len(img))
					ill = str(img.get("src"))
					print ill
					break
			
		elif newspaper == "vg":
			art = soup.find(id = "brodtekst_uten_bilde")
			body = replacer(str(art))
			body = easyReplacer(body)
			body = body.replace('<p id="brodtekst_uten_bilde">', "<p>")
			
			text = BeautifulSoup(str(body))
			bgone = text.findAll({'a':True, 'img':True, 'table':True})  #
			for b in bgone:
				print "len(b.contents) : " + str(len(b.contents))
				if b.contents == []:
					continue
				else:
					print "inni" 
					body = str(body).replace(str(b), str(b.contents[0]))

			ill = ""
			for img in soup.findAll('img'):
				if str(img.get("class")) == "edrumImageArticle":
					ill = str(img.get("src"))
					break
					
		elif newspaper == "ad":
			art = soup.findAll("body")
			temp = replacer(str(art))
			temp = easyReplacer(temp)
			body = "".join(temp)
			ill = ""
			
		body = easyReplacer(body)
		dd = {"body": body, "ill":ill}		
		article.update(dd)
		new_articles = True
		pickle.dump(article, open(pickledir + article["title"].lower().replace(" ", "_").replace("/", "")+".p", "w" ))
		news.append(article)
	
	new_articles = True
	return (news, new_articles)



def getArticlesAllRSS(rssurl, newspaper="ud"):
	pickledir = "/home/hraune/Master_prog/pdf/pickle/"
	pdfdir = "/home/hraune/Master_prog/pdf/"
	new_articles = False
	
	xml = ""
	
	try:
		xml = urllib.urlopen(rssurl)
	except IOError:
		print "rssfeed not active, falling back on local copy"
		xml = open("/home/hraune/Master_prog/ud.xml")
	soup = BeautifulStoneSoup(xml)
	
	articles = soup.findAll("article")

	news = []
	processed = []
	for article in articles:
		art = {}
		title = replacer(article.titleTag.renderContents())
		
		if title[0] == "?":
			title = title.replace("?", "-")
			
		if title in processed:
			continue
		else:
			processed.append(title)
		
		art["gibberish"] = False
		
		if "sdf" in title or "dsf" in title or len(title) == 1:
			print "i am gibberish!!! " + title
			art["gibberish"] = True
			art["pickled"] = False
			continue
			
		
		try:
			# Load the dictionary back from the pickle file.
			pickled_article = pickle.load(open(pickledir + title.lower().replace(" ", "_") + ".p" ))
			print "Found pickle: " + pickled_article["title"]
			if pickled_article["title"] == title:
				pickled_article["pickled"] = True
				pickled_article["gibberish"] = False
				news.append(pickled_article)
				continue
		except:
			print "article was not pickled! " + title
			art["gibberish"] = False
			art["title"] = title
			art["pickled"] = False
			art["category"] = replacer(article.sectionTag.renderContents(), False)
			
			au = str(article.authorTag)
			if au[9:20] == "<published>":
				art["author_text"] = ""
			else:
				art["author_text"] = replacer(article.authorTag.renderContents(), False)
				
			test = str(article.summaryTag)
			if test[10:16] == "<text>":
				art["ingress"] = ""
			else:
				art["ingress"] = replacer(article.summaryTag.renderContents(), False)
			
			publ = article.publishedTag.renderContents()
			publ = publ[-10:]
			publ = publ[6:] + publ[3:5] + publ[:2]
			art["published"] = publ
			if article.imagelinkTag:
				art["ill"] = article.imagelinkTag.renderContents()
			else:
				art["ill"] = None
			art["body"] = replacer(article.textTag.renderContents(), False)
			art["author_ill"] = "n/a"
			print "title: " + art["title"] + " >-< " + art["category"] + "(" + str(publ) + ")"
			news.append(art)
	
	ud_urls = {	"Nyhet": "http://www.underdusken.no/nyhet", "Reportasje": "http://www.underdusken.no/reportasje",
				"Kultur": "http://www.underdusken.no/kultur", "Editorial": "http://www.underdusken.no/meninger/leder",
				"Kommentar": "http://www.underdusken.no/meninger/kulturkommentar", "Meninger": "http://www.underdusken.no/meninger",
				"Leserbrev": "http://www.underdusken.no/meninger/leserbrev", "Anmeldelser": "http://www.underdusken.no/anmeldelser",
				"Kronikker": "http://www.underdusken.no/meninger/kronikker", "UKA-07": "http://www.underdusken.no/kultur/uka-07" }
	
	itr = 0
	print 
	print "Next: fetch bodytexts for articles"
	print

	pages = {}	
	extrasoup = ""

	for article in news:
		if article["gibberish"] == True:
			print "gibberish article"
			continue
		if article["pickled"] == True:
			print "this was fetched from a pickle: " + article["title"] + ", " + article["category"]
			continue
		else:
			print ""
				
			title = article["title"]
			print "Preparing to fetch bodytext for article:>"+title+"<"
			
			partial_url = ud_urls[article["category"]]
			
			url = ""
			body = ""
			asoup = ""
			
			print "Starting at: ", partial_url

			if article["category"] not in pages:
				sleep(random.random()*3)
				asoup = BeautifulSoup(urllib.urlopen(partial_url))
				pages[article["category"]] = asoup
				print "first of category: " + article["category"]			
			else:
				asoup = pages[article["category"]]
				print "second ++ of category: " + article["category"]
								
			funky = 0
			
			if title[0] == "-":
				print "funkytitle" + title[0]
				funky = 1
			
			
			print "funky", str(funky)
			
			for link in asoup.findAll('a'):
				turl = link.get("href").strip()
				turl = turl.split("/")[-1]
				if str(link.contents[0]) == title:
					url = link.get("href").strip()
					print "Found: ", str(url)
					break
				elif str(turl) == str(title.replace(" ", "+").lower()):
					url = link.get("href").strip()
					break
				elif funky and str(link.contents[0])[2:] == title[2:]:
					url = link.get("href").strip()
					print "Found: ", str(url)
					break

			if url == "":
				if extrasoup == "":
					extrasoup = BeautifulSoup(urllib.urlopen("http://underdusken.no"))
				for link in extrasoup.findAll('a'):
					turl = link.get("href").strip()
					turl = turl.split("/")[-1]
					
					if str(link.contents[0]) == title:
						url = link.get('href').strip()
						print "Correct url found in extrasoup: ", str(url)
						break
					elif str(turl) == str(title.replace(" ", "+").lower()):
						url = link.get("href").strip()
						break
					elif funky and str(link.contents[0])[2:] == title[2:]:
						url = link.get("href").strip()
						print "Funkyfound: ", str(url)
						break
				if url == "":
					print "Found no correct url at all, using supplied text, and pickles it."
					article["pickled"] = True
					b = article["body"]
					p = re.compile(r"[a-z][.][A-Z]")
					iterator = p.finditer(b)
					if iterator:
						print "doing regex magic"
						for match in iterator:
							span = match.span()
							bdot = span[0] + 1
							adot = span[1] - 1
							b.replace(b[bdot:adot], b[bdot:adot] + " </br></br>")
						
					pickle.dump(article, open(pickledir + article["title"].lower().replace(" ", "_")+".p", "w" ))
					continue
				else:
					print "Parsing: ", url
					temp = urlopen(url)

			else:
				print "Parsing: ", url
				temp = urlopen(url)
			
			
			bsoup = BeautifulSoup(temp)
			author_ill = bsoup.find("li", {"class": "photo"})
			art = bsoup.find(id="article")
			
			if "<script" in str(art):
				print "script in article body... pickles with supplied article body"
				pickle.dump(article, open(pickledir + article["title"].lower().replace(" ", "_")+".p", "w" ))
				continue
			if art == None:
				print "This is no article, uses supplied text"
				art["pickled"] = True
				continue
			
			body = ""
			
			if '<div class="rightImage">' in str(art):
				body = str(art).split('<div class="rightImage">')
			elif '<div class="leftImage">' in str(art):
				body = str(art).split('<div class="rightImage">')
			else:
				body = str(art).split('<div class="ingress">')
			
			body = body[1].split("</div>")[1]
			body = body.split('<div id="mediaResources">')[0]
			

			article["author_ill"] = str(author_ill).split('</a>')[0].split('">')[-1]
			article["body"] = replacer(body, True)
			article["pickled"] == True
			new_articles = True
			print "Article pickled and new articles is True: " + article["title"]
			pickle.dump(article, open(pickledir + article["title"].lower().replace(" ", "_")+".p", "w" ))
			
			print "body: "
			print article["body"]
			print "success!"

	print "Done fetching all articles"
	return (news, new_articles)
	

if __name__ == '__main__':
	ud_n = "http://ikaros.underdusken.no:8888/feed/ud.xml"
	vg = "http://www1.vg.no/rss/create.php?categories=12,10&keywords=&limit=10"
	db = "http://www.dagbladet.no/rss/sport/"
	
	news = getArticles(db, "db")
	

