#article.py

import xml.dom.minidom
from xml.sax.saxutils import escape

class Article:
	"""represents a block of text and metadata created from XML"""

	def __init__(self):
		"""set initial data properties"""
		self.reset()
		
	def reset(self):
		"""function for initializing data properties"""
		#title
		self.title = ""
		self.subtitle = ""
		self.category = ""
		
		#authors
		self.author_text = ""
		self.author_ill = ""
		
		#contents
		self.ingress = ""
		self.body = ""
		self.ill = ""
		self.caption = ""
		
		#management data
		self.size = 0
		self.time = ""
				
	def getXML(self):
		""" returns XML after reassembling from data members that may have changed """
		return ""
		
				
	def fromXML(self, node_data):
		"""get article data from an XML element passed as element from nodelist."""
		self.reset()
		
		
		self.title = get_attribute(node_data, "title")
		self.subtitle = get_attribute(node_data, "subtitle")
		self.category = get_attribute(node_data, "category")
		
		
		nodelist_a = node_data.getElementsByTagName("author")
		print nodelist_a
		#print "printing nodelista!"
		if nodelist_a:
			assert len(nodelist_a)<=1
			for node in nodelist_a:
				textnodes = node_data.getElementsByTagName("text")
				if textnodes:
					assert len(textnodes) == 1
					textnode = textnodes[0]
					textnode.normalize()
					if textnode.childNodes:
						self.author_text = textnode.firstChild.data.strip()
				
				illnodes = node_data.getElementsByTagName("ill")
				if illnodes:
					assert len(illnodes) == 1
					illnode = illnodes[0]
					illnode.normalize()
					if illnode.childNodes:
						self.author_ill = illnode.firstChild.data.strip()
				
		
		nodelist_i = node_data.getElementsByTagName("ingress")
		if nodelist_i:
			assert len(nodelist_i) >= 1
			ingress = nodelist_i[0]
			ingress.normalize()
			if ingress.childNodes:
				self.ingress = ingress.firstChild.data.strip()
				
		
		nodelist_t = node_data.getElementsByTagName("body")
		if nodelist_t:
			assert len(nodelist_t) >= 1
			body = nodelist_t[0]
			body.normalize()
			if body.childNodes:
				self.body = body.firstChild.data.strip()
		
		
		#photo and other ill
		nodelist_p = node_data.getElementsByTagName("illustration")
		if nodelist_p:
			assert len(nodelist_p) >= 1
			node = nodelist_p[0]
			node.normalize()
			self.caption = node.getAttribute("caption").strip()
			if node.childNodes:
				self.ill = node.firstChild.data.strip()
	


#helper functions:				
def get_attribute(node, attrname):
	"""return the value of a solitary element & attribute if available"""
	return node.getAttribute(attrname).strip()
