#newspaper.py
from article import Article
import xml.dom.minidom
from xml.dom.ext.reader.Sax2 import FromXmlStream
from shutil import copyfile

class Newspaper:
	"""Stores and retrieves articles from newspaper xml files."""
	
	def saveToFile(self, article):
		"""save as <article.title>.xml"""
		sFilename = article.title + ".xml"
		fd = open(sFilename, "w")
		
		#write file to disk with data from getXML call
		fd.write(article.getXML())
		fd.close()
		
	def load(self, sName):
		"""name must be filename.xml, returns a list of article objects"""
		fd = open(sName, "r")
		sxml = fd.read()
		article_list = []
		
		dom = xml.dom.minidom.parseString(sxml)
		
		issuelist = dom.getElementsByTagName("enewspaper")
		if issuelist:
			assert len(issuelist) == 1
			enewspaper = issuelist[0]
			issue = enewspaper.getAttribute("issue").strip()
			volume = enewspaper.getAttribute("volume").strip()
				
			
		
		#populate article list with articles
		nodelist = dom.getElementsByTagName("article")
		if nodelist:
			assert len(nodelist) >= 1
			for article in nodelist:
				article.normalize()
				a = Article()
				a.fromXML(article)
				article_list.append(a)
						
		fd.close
		return {'article_list':article_list, 'issue':issue, 'volume':volume}
				
