# Logic for preparing the content that are to be used by the templates.

from enews.enewspaper.models import Article
from django.views.generic.list_detail import object_detail
from django.shortcuts import render_to_response

#Renders the detail template with pageable content. Returns a HttpResponse object.
def detail(request, slug):
	a = Article.objects.filter(slug__exact = slug)
	body = a[0].body
	
	#number of chars in body
	body_chars = len(body)
	
	#number of chars to divide on page 1
	#room for about 1400 bodychars on p1
	#room for about 2500 bodychars on p2, p3, etc.
	div_p1 = 1400
	div_ps = 2500
	
	p1_body = body[:div_p1] + "-"
	page2_body = body[div_p1:(div_p1+div_ps)]
	
	newlist = {	'title':a[0].title, 
				'subtitle':a[0].subtitle, 
				'ingress':a[0].ingress, 
				'author':a[0].author, 
				'illustration':a[0].illustration, 
				'body':p1_body}
	
	rtr = render_to_response('enewspaper/article_detail.html', {"object":newlist, "page":1})
	return rtr
	

def detail_pages(request, slug, page):
	a = Article.objects.filter(slug__exact = slug)
	body = a[0].body
	
	page2_body = body[1400:]
	
	newlist = {	'title':a[0].title, 
				'subtitle':a[0].subtitle, 
				'ingress':a[0].ingress, 
				'author':a[0].author, 
				'illustration':a[0].illustration, 
				'body':page1_body}
				
	return ""
