# coding: latin-1
#index.py

from __future__ import division
from django.core.management import setup_environ
from enews import settings
from django.template.loader import render_to_string
import operator
import time
from manifest import replaceNor


setup_environ(settings)

#takes a list of categories and a list of tuples of article titles and its categories and pages pr article
#returns a cat_list with all articles sorted after categories, each article represented as a dict.
def createIndex(categories, articles, save_path = "/home/hraune/Master_prog/html/"):
	#tar inn en liste med kategorier og en liste med tupler av artikkeltitler og dens kategorier + antall sider pr artikkel.
	#returnerer en cat_list med alle artikler sortert etter kategorier, artikkelen er representert som en dict.
	
	sorted_art = sorted(articles, key=operator.itemgetter(1))
	categories = sorted(categories)
	
	cat_list = []
	
	
	for cat in categories:
		c_dict = {"category":cat}
		article_list = []
		for art in sorted_art:
			if art[1] == cat:
				title = art[0]
				url = title + "_p" + str(1) + ".html"
				url = replaceNor(url)
				art_dict = {}
				art_dict['title']= title
				art_dict['url']= url
				art_dict['pages'] = art[2]
				article_list.append(art_dict)
			c_dict["articles"]=article_list
		cat_list.append(c_dict)
	
	index_html = render_to_string('enewspaper/index_epaper.html', {'categories':cat_list})
	
	index_html = index_html.encode('utf-8')
	
	
	filename = "index.html"
	
	indexfile = open(save_path + filename, 'w')
	indexfile.write(index_html)
	print "Writing to file: index.html"
	indexfile.close()
	
	return cat_list
