# coding: latin-1
#Manifest.py

import time
from math import ceil

#creates a manifest file for the iLiad
def makeManifest(volume, cat_list, save_to_path = "/home/hraune/Master_prog/html/"):
	#tar inn volume, samt en cat_list som er en index generert av createIndex, samt en path som man skal lagre til.
	
	
	#tab
	t = "\t"
	
	#header
	header = '<?xml version="1.0" encoding="iso-8859-1"?>' + "<package>\n" + t +"<metadata>\n"
	
	#dc-metadata
	today = time.strftime("%Y-%m-%dT%H:%M:%S", time.localtime())
	
	title = 3*t + "<Title> Under Dusken </Title>\n"
	description = 3*t + "<Description> Studentavisa i Trondheim </Description>\n"
	date = 3*t + "<Date>" + today + "</Date>\n"
	format = 3*t + "<Format/>\n"
	id = 3*t + "<Identifier/>\n"
	lang = 3*t + "<Language>no</Language>\n"
	type = 3*t + "<Type>newspaper</Type>\n"
		
	#y-metadata	
	filesize = 3*t + "<FileSize>000</FileSize>\n"
	itemsize = 3*t + "<ItemSize>000</ItemSize>\n"
	startpage = 3*t + "<startpage>index.html</startpage>\n"
	image = 3*t + "<image/>\n"
	version = 3*t + "<version/>\n"
	
	dc_meta = 	2*t + "<dc-metadata>\n" + title + description + date + format + id + lang + type + 2*t + "</dc-metadata>\n"
				
	y_meta = 	2*t + "<y-metadata>\n" + filesize + itemsize + startpage + image + version + 2*t + "</y-metadata>\n"
	
	mid = 	t + "</metadata>\n" + t + "<index>\n"
	
	pageitems = []
	
	pageitems.append(3*t + "<page number="+'"01"'+" url="+'"index.html"'+"/>\n")
	
	c = 2
	
	for cat in cat_list:
		articles = cat['articles']
		for article in articles:
			pages = int(article['pages'])
			for i in range(1, pages+1):
				url =  article['title'] + "_p" + str(i) + ".html"
				url = replaceNor(url)
				if c < 10:
					pageitems.append(3*t + "<page number='0" + str(c) + "' url='" + url + "'/>\n")
				else:
					pageitems.append(3*t + "<page number='" + str(c) + "' url='" + url + "'/>\n")
				c += 1

	pages = ""
	for item in pageitems:
		pages += item
	
	count = len(pageitems)
	
	pagelist = 2*t + "<pagelist type=" + '"standard"' + "count='" + str(count) + "'>\n"
	
	end = 2*t + "</pagelist>\n" + t + "</index>\n" + "</package>"
	
	manifest = 	header + dc_meta + y_meta + mid + pagelist + pages + end
	
	manifest_xml = open(save_to_path + "manifest.xml", 'w')
	manifest_xml.write(manifest.encode("utf-8"))
	print "Writing to file: manifest.xml"
	manifest_xml.close()
	
#removes/normalizes scandinavian and latin-1 type letters as well as "?" which the iliad dont like in filenames
def replaceNor(s):
	import unicodedata
	s = s.replace("?", "")
	return s
