# coding: latin-1
#renderarticle.py

from __future__ import division
from math import ceil
from django.template.loader import render_to_string
from manifest import replaceNor

import ho.pisa as pisa

import cStringIO as StringIO


from django.template.loader import get_template
from django.template import Context

from django.core.management import setup_environ
from enews import settings
import logging
logging.raiseExceptions = 0

setup_environ(settings)


#helpfunction for calculating pages
def calcPages(body_len, len_p1=1400, len_pp=2500):
	number_2pages = ceil((body_len - len_p1)/len_pp)
	
	if number_2pages < 0:
		number_2pages = 0
	
	return number_2pages + 1


#Helpfunction for creating dictionaries of the elements of an article. 
def create_newsdict(page, article, (lenp1, lenp2)):
	custom_body = ""
	
	if page == 1:
		custom_body = article.body[:lenp1]
	else:
		custom_body = article.body[lenp1+(lenp2*(page-2)):lenp1+(lenp2*(page-1))]
	
	render_dict = {	'title':article.title, 
					'subtitle':article.subtitle, 
					'ingress':article.ingress, 
					'author':article.author, 
					'illustration':article.illustration, 
					'body':custom_body,
					'page':page }

	return render_dict
	
#helpfunction 2
def create_newsdict_dict(page, article, (lenp1, lenp2)):
	custom_body = ""
	
	if page == 1:
		custom_body = article["body"][:lenp1]
	else:
		custom_body = article["body"][lenp1+(lenp2*(page-2)):lenp1+(lenp2*(page-1))]
		
	title = article["title"].encode("utf-8")
	ingress = article["ingress"].encode("utf-8")
	
	render_dict = {	'title': article["title"], 
					#'subtitle': article["subtitle"], 
					'ingress': article["ingress"], 
					'author': article["author_text"], 
					'illustration': article["author_ill"], 
					'body': custom_body,
					'page': page }

	return render_dict
	
#helpfunction 3
def create_newsdict2(article):
	
	ill = article["author_ill"]
	if not ill:
		ill = ""
	
	render_dict = {	'title': article["title"], 
					#'subtitle': article["subtitle"], 
					'ingress': article["ingress"], 
					'author': article["author_text"], 
					'illustration': ill, 
					'body': article["body"] }

	return render_dict

#renders article pages in HTML
def render_article(article, isSlug=True, save_to_path="/home/hraune/Master_prog/html/"):
	
	if isSlug:
		slug = article
		articles = Article.objects.filter(slug__exact = slug)
		article = articles[0]
	
	len_p1 = 1400
	len_pp = 2500
	page_params = (len_p1, len_pp)

	#print "Loaded article: " + article.title
	
	if isSlug:
		body_len = len(article.body)
	else:
		body_len = len(article["body"])

	#number of pages that are of type page2+
	#n_2pages = ceil((body_len - len_p1)/len_pp)
	#if n_2pages < 0: n_2pages = 0
	
	n_pages = calcPages(body_len)
	
	print "Preparing to write: " + article.title + ": " + str(n_pages) + " pages."
	
	filenames = []
	
	#generating the pages
	for page in range(1, int(n_pages)+1):
		if isSlug:
			d = create_newsdict(page, article, page_params)
			filename = article.title + "_p" + str(page)
			filename = replaceNor(filename)
		else:
			d = create_newsdict_dict(page, article, page_params)
			filename = article["title"] + "_p" + str(page)
			filename = replaceNor(filename)
			
		
		filename_html = filename + ".html"
		
		filenames.append(filename_html)
		
		htmlfile = open(save_to_path + filename_html, 'w')
		if page == 1:
			art_html = render_to_string('enewspaper/article_detail_epaper.html', {"object":d, "page":page, "start":True})
		else:
			art_html = render_to_string('enewspaper/article_detail_epaper.html', {"object":d, "page":page, "start":False})
		
		print "Writing to file: " + filename
		
		art_html = art_html.encode('utf-8')
		
		htmlfile.write(art_html)
		htmlfile.close()
		
		
	all_d = create_newsdict2(article)	
	filename_pdf = article["title"] + ".pdf"
		
	#pdf
	pdffile = open(save_to_path + filename_pdf, "w")
	art_pdf = render_to_pdf('enewspaper/entries.html', {
												'pagesize':'A6',
												'title':'Test',
												'object':all_d,
												'start':True}, pdffile)
	pdffile.close()
		
	
#courtesy of ezpdf example in pisa documentations
def render_to_pdf(template_dict, context_dict, dest):
    '''
    Renders a context to a template. The endproduct is a PDF via HTML.
    The context is a dictionary, while the template is a Django HTML file
    '''
    template = get_template(template_dict)
    context = Context(context_dict)
    html  = template.render(context)
    result = StringIO.StringIO()
    pdf = pisa.pisaDocument(StringIO.StringIO(html.encode("utf-16")), dest)
    if not pdf.err:
        return pdf
    return None
	
	
	
from reportlab.pdfgen import canvas
from django.http import HttpResponse

	
if __name__ == "__main__":
	s = """
		<document pagesize="a6">
		<template name="secondPage">
			<frame box="1cm 1cm 10cm 10cm">
		</template>
		<h1>Hello</h1>
		<ol>
			<li> first
			<li> second
		</ol>
		<nexttemplate name="secondPage">
		<nextpage>
		Top left corner of second page.
		</document>
		"""
		
	pdf = pisa.pisaDocument(s, open("test2.pdf","wb"))
