#!/usr/bin/perl -w
#
#
package ids::dispatcher;
use strict;
use vars ('@ISA');
use XML::Writer;
use URI::Escape;
use HTML::Entities ();
use Data::Dumper;
use XML::Mini::Document;

sub new
{
        my($it,$xml) = @_;
	$ENV{REMOTE_USER}='chris';
	my $class= ref($it) || $it;
	my $self={};
        bless $self,$it;
	$self->new_by_incoming_xml($xml);
        return $self;
}



sub new_by_incoming_xml
{
	my($it,$xml_in)=@_;
	$XML::Mini::AutoEscapeEntities=0;
	xlog(" raw xml: $xml_in");
	$xml_in=uri_unescape($xml_in);
	my $x=XML::Mini::Document->new();
	$x->parse($xml_in);
	xlog("--- receiving xml ---");
	my $dump_xml=$xml_in;
	$dump_xml=~s/>/>\n/g;
	if($xml_in!~/<\?\s*xml/)
	{
		xlog("no valid xml found in: $xml_in");
		return;
	}
	my $command;
	if($x->getElementByPath('/Request')->getAllChildren()->[0])
	{
		$command=$x->getElementByPath('/Request')->getAllChildren()->[0]->name();
		xlog("got command: $command");
	}
	else
	{
		xlog("no command - so just doing a ping");
	}
	$it->{xml}=$x;

	if($command eq 'GetServerURI')
	{
		$it->GetServerURI();
	}
	elsif($command eq 'GetUpgradeSoftware')
	{
		$it->GetUpgradeSoftware();
	}
	elsif($command eq 'AssociatePrimaryUser')
	{
		$it->AssociatePrimaryUser();
	}
	elsif($command eq 'AnnounceToServer')
	{
		$it->AnnounceToServer();
	}
	elsif($command eq 'GetContent')
	{
		$it->GetContent();
	}
	else
	{
		xlog("unknown command: $command - doing a ping instead");
	}
	$it->create_response();
}

sub GetServerURI
{
	my $it=shift;
	my $xml;
	my $build=XML::Writer->new(DATA_MODE=>1,DATA_INDENT=>3,UNSAFE=>1,OUTPUT=>\$xml);
	$build->startTag('Status');
	$build->dataElement('Code',0);
	$build->endTag('Status');
	$build->startTag('PerformCommands');
		$build->startTag('SetServerURI','CommandID' => 1);
		$build->dataElement('URI','http://10.0.1.7:80/eserver2');
		$build->endTag('SetServerURI');
		$build->emptyTag('AnnounceToServer','CommandID' => 2);
	$build->endTag('PerformCommands');
	$build->end();
	$it->{response}=$xml;
}


# ok, these are wrong, but we don't have a transcript yet...

sub GetUpgradeSoftware
{
	my $it=shift;
	my $xml;
	my $build=XML::Writer->new(DATA_MODE=>1,DATA_INDENT=>3,UNSAFE=>1,OUTPUT=>\$xml);
	$build->startTag('Status');
	$build->dataElement('Code',0);
	$build->endTag('Status');
	$build->startTag('PerformCommands');
		$build->startTag('SetServerURI','CommandID' => 1);
		$build->dataElement('URI','http://10.0.1.7:80/eserver2');
		$build->endTag('SetServerURI');
		$build->emptyTag('AnnounceToServer','CommandID' => 2);
	$build->endTag('PerformCommands');
	$build->end();
	$it->{response}=$xml;

}

sub AssociatePrimaryUser
{
	my $it=shift;
	my $xml;
	my $build=XML::Writer->new(DATA_MODE=>1,DATA_INDENT=>3,UNSAFE=>1,OUTPUT=>\$xml);
	$build->startTag('Status');
	$build->dataElement('Code',0);
	$build->endTag('Status');
	$build->startTag('PerformCommands');
		$build->startTag('SetServerURI','CommandID' => 1);
		$build->dataElement('URI','http://10.0.1.7:80/eserver2');
		$build->endTag('SetServerURI');
		$build->emptyTag('AnnounceToServer','CommandID' => 2);
	$build->endTag('PerformCommands');
	$build->end();
	$it->{response}=$xml;
}

sub AnnounceToServer
{
	my $it=shift;
	my $xml;
	my $build=XML::Writer->new(DATA_MODE=>1,DATA_INDENT=>3,UNSAFE=>1,OUTPUT=>\$xml);
	$build->startTag('Status');
	$build->dataElement('Code',0);
	$build->endTag('Status');
	$build->startTag('PerformCommands');
		$build->startTag('SetServerURI','CommandID' => 1);
		$build->dataElement('URI','http://10.0.1.7:80/eserver2');
		$build->endTag('SetServerURI');
		$build->emptyTag('AnnounceToServer','CommandID' => 2);
	$build->endTag('PerformCommands');
	$build->end();
	$it->{response}=$xml;
}

sub GetContent
{
	my $it=shift;
	my $xml;
	my $build=XML::Writer->new(DATA_MODE=>1,DATA_INDENT=>3,UNSAFE=>1,OUTPUT=>\$xml);
	$build->startTag('Status');
	$build->dataElement('Code',0);
	$build->endTag('Status');
	$build->startTag('PerformCommands');
		$build->startTag('SetServerURI','CommandID' => 1);
		$build->dataElement('URI','http://10.0.1.7:80/eserver2');
		$build->endTag('SetServerURI');
		$build->emptyTag('AnnounceToServer','CommandID' => 2);
	$build->endTag('PerformCommands');
	$build->end();
	$it->{response}=$xml;
}


sub xlog
{
	my $message=shift;
	ylog($message,'idsxml');
}

sub ylog
{
	my($msg,$file)=@_;
	my($now,@tim,$year,$month);
	@tim=localtime;
	$year=$tim[5]+1900;
	$month=sprintf("%02d",$tim[4]+1);
	$file="weblog" unless $file;
	$file=~s!^/!!;
	open FHCJ1,">>/usr/web/logs/$file.$year-$month";
	print FHCJ1 sprintf("%02d/%02d/%4d %02d:%02d:%02d - ",$tim[3],$tim[4]+1,$year,$tim[2],$tim[1],$tim[0]),$msg,"\n";
	close FHCJ1;
}

sub create_response
{
	my $it=shift;
	my $xml;
	my $build=XML::Writer->new(DATA_MODE=>1,DATA_INDENT=>3,UNSAFE=>1,OUTPUT=>\$xml);
	my $now=time;
	$build->xmlDecl("UTF-8");
	$build->startTag('Response','ProtocolType','EReader','ProtocolVersion',1,'UnixTimestamp',$now);
	$build->raw($it->{response});
	$build->endTag('Response');
	$build->end();
	$it->{response}=$xml;
	xlog("Response.....\n$xml");
}


sub generate_response_data
{
	my($it,$x)=@_;
	if($it->{result}{type} eq 'object')
	{
		return($it->generate_object($x));
	}
	elsif($it->{result}{type} eq 'objectarray')
	{
		return($it->generate_objectarray($x));
	}
	elsif($it->{result}{type} eq 'hash')
	{
		return($it->generate_hash($x));
	}
}

sub generate_object
{
	my($it,$x)=@_;
	my $o=$it->{result};
	$x->startTag('object','class',$o->{class},'id',$o->{id});
		for my $property (keys %{$o->{properties}})
		{
			$x->dataElement($property,$o->{properties}{$property});
		}
	$x->endTag('object');
}

sub generate_objectarray
{
	my($it,$x)=@_;
	my $array=$it->{result}{properties};
	my $rsave=$it->{result};
	foreach my $object (@$array)
	{
		$it->{result}=$object;
		$it->generate_object($x);
	}
	$it->{result}=$rsave;
}

sub generate_hash
{
	my($it,$x)=@_;
	my $o=$it->{result};
	for my $property (keys %{$o->{properties}})
	{
		$x->dataElement($property,$o->{properties}{$property});
	}
}

sub addmessage
{
	my($it,$message)=@_;
#	$it->{message}.="$message\n";
	push @{$it->{messages}},$message;
}


1;
