#!/usr/bin/perl -w

#
# ids.pl - send a command to an IDS sever
#


use strict;
use LWP;


#----------------------------------------------------------------


# First create some content

my $r={};
init_request($r);
GetServerURI($r);
end_request($r);


# Now create a LWP request object


my $call = create_call($r);


# and a UserAgent object

my $ua = LWP::UserAgent->new;


# and POST it off

my $response = $ua->request($call);


# now check to see what we got back

if ($response->is_success) 
{
	print $response->content,"\n";
} 
else 
{
	print "ERROR: ",$response->status_line,"\n";
}




#------------------------------------------------------------------


#
# An example IDS call
#

sub GetServerURI
{
	my $r=shift;
	my $c= "<GetServerURI></GetServerURI>\n";
	$r->{content}.=$c;
}


#
# Add an XML and IDS request header
#

sub init_request
{
	my $r=shift;
	$r->{content} = qq|<?xml version="1.0" encoding="UTF-8"?>\n|;
	$r->{content}.= qq|<Request ProtocolType="Ereader" ProtocolVersion="1">\n|;
}


#
# Add a footer
#

sub end_request
{
	my $r=shift;
	$r->{content}.=qq|</Request>\n|;
}


#
# Make an LWP request object with the correct headers
#

sub create_call
{
	my $r=shift;
	my $call = HTTP::Request->new("POST");
	$call->header("Accept","*/*");
	$call->header("eserver-eui64","00167CFFFF000000");
	$call->header("eserver-productid","000000000002");
	$call->header("eserver-requestversion","1");
	$call->header("Content-Type","application/x-www-form-urlencoded");
	$call->content($r->{content});
	$call->url("https://ids.irexnet.com/redirector");
	return($call);
}

