#!/bin/sh
# enhanced downloader using a script for the manifests.

set -x
export WDIR=/mnt/free/newspapers/enhUnderDusken
export IDIR=/mnt/free/newspapers/enhUnderDusken/downloadUD
export ADIR=/mnt/free/newspapers/enhUnderDusken/Forrige
export SDIR=/mnt/free/newspapers/enhUnderDusken/log

date >> $SDIR/log.txt
echo Wireless trondheim downloader >> $SDIR/log.txt

/usr/bin/wireless.sh start WirelessTrondheim
if [ $? -ne 0 ]; then
	echo Failed to connect to wireless >> $SDIR/log.txt
	cp $IDIR/iconA.png $SDIR/icon.png
	$IDIR/manifester.sh "Logg" "Klarte ikke å koble seg til Trådløse Trondheim" > $SDIR/manifest.xml
	exit 1 
fi

i=ud

mv $IDIR/contents.txt $IDIR/old_contents.txt
wget -O $IDIR/contents.txt http://folk.ntnu.no/hakonror/iliad/pdf/contents.txt

# if not able to download, exit
if [ $? -ne 0 ]; then
	echo Failed to download contentfile >> $SDIR/log.txt
	cp $IDIR/iconA.png $SDIR/icon.png
	$IDIR/manifester.sh "Logg" "Klarte ikke å laste ned innholdsfila" > $SDIR/manifest.xml
	exit 1 
fi

loc=$(cat old_contents.txt)
serv=$(cat contents.txt)

echo loc: $loc >> $SDIR/log.txt
echo serv: $serv >> $SDIR/log.txt

if [ $serv -gt $loc ]; then
	rm -rf $ADIR/$i.pdf
	rm /tmp/$i.pdf
	mv $WDIR/$i.pdf $ADIR 
	mkdir -p $WDIR/$i.pdf
	$IDIR/manifester.sh "Under Dusken" "Studentavisa i Trondheim" > $WDIR/$i.pdf/manifest.xml

	wget -O /tmp/$i.pdf http://folk.ntnu.no/hakonror/iliad/pdf/$i.pdf
	# if not able to download, exit
	if [ -f /tmp/$i.pdf ]; then
		echo Newspaper downloaded >> $SDIR/log.txt
		cp $IDIR/iconB.png $SDIR/icon.png
		./manifester.sh "Logg" "Avis nedlastet" > $SDIR/manifest.xml
		mv /tmp/$i.pdf $WDIR/$i.pdf/$i.pdf
		cp $IDIR/icon.png $WDIR/$i.pdf/icon.png
		/usr/bin/wireless.sh stop
		exit 0
	fi
	echo Failed to download newspaper >> $SDIR/log.txt
	cp $IDIR/iconA.png $SDIR/icon.png
	$IDIR/manifester.sh "Logg" "Klarte ikke å laste ned avisen" > $SDIR/manifest.xml
	/usr/bin/wireless.sh stop
	exit 1 	
fi
set +x

