#!/bin/sh
dir=`/usr/bin/dirname $0`
connectmanifest="$dir/../connect/manifest.sh"
date=`date +%FT%T`
status=`ifconfig |grep inet|grep -v 127.0.0.1|sed -e 's/^ *//g'`
essid=`cat "$dir/../connect/essid"`

if [ -z "$status" ]
then
  status='Disconnected.'
  if [ -z "$essid" ]
  then
    "$connectmanifest" "No Connection" "Please select a network profile first." "$date" ""
  else
    "$connectmanifest" "Connect to Wireless Network" "" "$date" connect.sh
  fi
else
  "$connectmanifest" "Disconnect from Wireless Network" "$essid" "$date" disconnect.sh
fi
"$dir/manifest.sh" "Network Status" "$status" "$date" status.sh
